﻿using UnityEngine;


namespace hry.labs.Combat
{

    [RequireComponent(typeof(Collider))]
    public class Damageable : MonoBehaviour
    {

        public Utility.FloatVariable HP;
        public Events.GameEvent OnDestroyed;
        public bool sharedHP = false;
        public bool destroyGameObject = true;


        private void Awake()
        {
            if (!sharedHP)
            {
                var hp = ScriptableObject.CreateInstance<Utility.FloatVariable>();
                hp.defaultValue = HP.defaultValue;
                hp.variable = HP.variable;
                HP = hp;
            }
        }

        private void OnTriggerEnter(Collider other)
        {
            var shot = other.gameObject.GetComponent<Combat.ShotBehaviour>();
            if (shot)
            {
                HP.variable -= shot.damage;

                if (HP.variable <= 0)
                {
                    OnDestroyed.Invoke();
                    if (destroyGameObject)
                        Destroy(gameObject);
                }
            }
        }

    }

}