﻿using System.IO;
using UnityEngine;
using UnityEngine.SceneManagement;

namespace hry.labs.Control
{

    public class Game : MonoBehaviour
    {

        public GameState gameState;
        public Object nextScene;


        private void Awake()
        {
            // Set some global settings
            Physics.IgnoreLayerCollision(LayerMask.NameToLayer(Utility.Constants.LAYER_EFFECTS), LayerMask.NameToLayer(Utility.Constants.LAYER_EFFECTS), true);
        }

        public void GameEnded()
        {
            gameState.lastPlayers.Insert(0, gameState.currentPlayer.variable);
            gameState.lastScores.Insert(0, gameState.currentScore.variable);

            if (gameState.lastPlayers.Count > 3)
            {
                gameState.lastPlayers.RemoveAt(3);
                gameState.lastScores.RemoveAt(3);
            }

            SaveGameState();
            SceneManager.LoadScene(nextScene.name);
        }

        public void SaveGameState()
        {
            var gameStateString = JsonUtility.ToJson(gameState);
            File.WriteAllText(Utility.Constants.PATH_TO_SAVE, gameStateString);
        }
    }

}