﻿using System.Collections.Generic;
using UnityEngine;


namespace hry.labs.Events
{

    [CreateAssetMenu(fileName ="GameEvent", menuName ="Game Event")]
    public class GameEvent : ScriptableObject
    {

        [SerializeField]
        private List<GameEventListener> listeners = new List<GameEventListener>();


        public void Register(GameEventListener listener)
        {
            listeners.Add(listener);
        }

        public void Remove(GameEventListener listener)
        {
            listeners.Remove(listener);
        }

        public void Invoke()
        {
            // Iterate from top of the list, so when an item is removed, it won't mess up the order.
            for (int i = listeners.Count - 1; i >= 0; --i)
            {
                listeners[i].OnEventRaised();
            }
        }

    }

}