﻿using UnityEngine;

namespace hry.labs.NPC.AI.Steering
{

    [CreateAssetMenu(fileName = "Arrival", menuName = "Steering/Arrival")]
    public class Arrival : Steer
    {

        public override Vector3 Act(SteeringAgent agent)
        {
            Vector3 toTarget = agent.target.variable - agent.transform.position;
            if (toTarget.magnitude < agent.slowingRadius.variable)
            {
                Vector3 arrival = -toTarget.normalized * (1.0f - toTarget.magnitude / agent.slowingRadius.variable);
                return arrival;
            }
            return Vector3.zero;
        }

#if UNITY_EDITOR
        public override void DrawGizmo(SteeringAgent agent)
        {
            Gizmos.color = Color.magenta;
            Vector3 toTarget = agent.target.variable - agent.transform.position;
            if (toTarget.magnitude < agent.slowingRadius.variable)
            {
                Vector3 arrival = -toTarget.normalized * (1.0f - toTarget.magnitude / agent.slowingRadius.variable);
                Gizmos.DrawLine(agent.transform.position, agent.transform.position + arrival);
            }
        }
#endif
    }

}