﻿using UnityEngine;

namespace hry.labs.NPC.AI.Steering
{
    [CreateAssetMenu(fileName ="Pursuit", menuName ="Steering/Pursuit")]
    public class Pursuit : Steer
    {

        public override Vector3 Act(SteeringAgent agent)
        {
            Vector3 target = (agent.target.variable + agent.targetVelocity.variable * agent.pursuitPrediction.variable);
            return (target - agent.transform.position).normalized;
        }

#if UNITY_EDITOR
        public override void DrawGizmo(SteeringAgent agent)
        {
            Vector3 target = (agent.target.variable + agent.targetVelocity.variable * agent.pursuitPrediction.variable);
            Gizmos.color = Color.red;
            Gizmos.DrawWireSphere(target, 0.05f);
            Gizmos.DrawLine(agent.transform.position, target);
        }
#endif
    }

}