﻿using UnityEngine;

namespace hry.labs.NPC
{

    public class EnemyCombat : MonoBehaviour
    {

        public Utility.FloatVariable searchRadius;
        public AI.Steering.SteeringAgent steeringAgent;
        public AI.Actions.PlanningAgent planningAgent;
        public Utility.Vector3Variable playerPosition;
        public Utility.Vector3Variable playerVelocity;
        public AI.State wanderState;
        public AI.State pursueState;

        private Utility.Vector3Variable _target;
        [SerializeField]
        private bool _chasing = false;



        void Start()
        {
            Utility.Vector3Variable target = ScriptableObject.CreateInstance<Utility.Vector3Variable>();
            Utility.Vector3Variable targetVelocity = ScriptableObject.CreateInstance<Utility.Vector3Variable>();
            // Set up references
            steeringAgent.target = target;
            steeringAgent.targetVelocity = targetVelocity;
            planningAgent.target = target;
            // Change list of actions
            steeringAgent.movement = wanderState.movement;
            planningAgent.actions = wanderState.actions;
        }

        void Update()
        {
            // While player notfound, keep searching. When found start chasing and shooting.
            bool inRadius = (playerPosition.variable - transform.position).sqrMagnitude < (searchRadius.variable * searchRadius.variable);
            if (!_chasing && inRadius)
            {
                // Player detected, start pursuing
                // Change list of actions
                steeringAgent.movement = pursueState.movement;
                planningAgent.actions = pursueState.actions;
                // Set variables
                steeringAgent.target = playerPosition;
                steeringAgent.targetVelocity = playerVelocity;
                planningAgent.target = playerPosition;
                _chasing = true;
            }
        }

        private void OnDrawGizmos()
        {
            Gizmos.color = Color.red;
            Gizmos.DrawWireSphere(transform.position, searchRadius.variable);
        }
    }

}