﻿using UnityEngine;

namespace hry.labs.Physic
{

    [RequireComponent(typeof(Rigidbody))]
    public class Hover : MonoBehaviour
    {

        public float hoverHeight = 1.0f;
        public float hoverForce = 10.0f;
        public Rigidbody rigidBody;

        private Ray _ray;


        private void Start()
        {
            _ray = new Ray
            {
                direction = Vector3.down
            };
        }

        private void FixedUpdate()
        {
            // Animation should be done in FixedUpdate as we do physical animation.
            _ray.origin = transform.position + Vector3.up * 0.001f;
            RaycastHit hit;
            if (Physics.Raycast(_ray, out hit, 100.0f))
            {
                float relativeDistance = Mathf.Min((hoverHeight - hit.distance) / hoverHeight, 1.0f);
                rigidBody.AddForce(Vector3.up * relativeDistance * hoverForce, ForceMode.Acceleration);
            }
        }

    }

}