﻿using UnityEngine;


namespace hry.labs.Player
{

    public class PlayerCombat : MonoBehaviour
    {

        public Combat.LaserGun laserGun;
        public Utility.FloatVariable playerSpeed;
        [Tooltip("Multiplies the addition of player's speed to the laser. So that the speed addition can be tweaked.")]
        [Range(0.0f, 2.0f)]
        public float shootSpeedMultiplier = 0.2f;


        private void Update()
        {
            // Use left mouse button to shoot lasers from blaster
            if (Input.GetMouseButtonDown(Utility.Constants.MOUSE_BUTTON_LEFT))
            {
                Ray ray = UnityEngine.Camera.main.ScreenPointToRay(Input.mousePosition);
                RaycastHit hit;
                // Hit anything but player
                if (Physics.Raycast(ray, out hit, 100.0f, ~LayerMask.GetMask(Utility.Constants.LAYER_PLAYER, Utility.Constants.LAYER_EFFECTS)))
                {
                    laserGun.ShootLaser(hit.point, playerSpeed.variable * shootSpeedMultiplier);
                }
            }
        }

    }

}